
#include <systemc>
#include "system_driver.h"
#include "topcell.h"

system_driver::system_driver(sc_core::sc_module_name name)
	: sc_core::sc_module(name),
	  m_clock("clock"),
	  m_resetn("resetn")
{
	topcell* m_topcell = new topcell("top");
	m_topcell->p_resetn(m_resetn);
	m_topcell->p_clock(m_clock);

	SC_THREAD(gen_clock);
}

system_driver::~system_driver()
{
	delete m_topcell;
}

void system_driver::gen_clock()
{
	m_clock = 0;
	m_resetn = 0;
	sc_core::wait(sc_core::sc_time(.5, sc_core::SC_NS));
	m_clock = 1;
	sc_core::wait(sc_core::sc_time(.5, sc_core::SC_NS));
	m_clock = 0;
	m_resetn = 1;

	for(;;) {
		sc_core::wait(sc_core::sc_time(.5, sc_core::SC_NS));
		m_clock = 1;
		sc_core::wait(sc_core::sc_time(.5, sc_core::SC_NS));
		m_clock = 0;
	}
}

SC_MODULE_EXPORT(system_driver);
